%% User inputs ---
A0 = ;
A1 = ;
tau = ;
control_basis = ;
h = ;
gamma = -0.1;
constraint = [];
cost_weight = 1;
cost_general = [];
searchmode = 'fmincon';
guess = [];
options = [];
%% Conditioning parameters --
eig_lower = 0;
eig_upper = inf;
spectrum_discretization = 10;
refining = 'false';

%% Script


n = length(A0);
k = (1/n)*size(control_basis)*[0;1];

if strcmp(refining,'true')==0
    [LAM,Phi0,Psi0,GAM,eigs_all] = dde_data(A0,A1,tau,spectrum_discretization,eig_lower,eig_upper);
    if eig_upper == inf
        fprintf('Found %d eigenvalues with real part at least %f for the input DDE, counting multiplicity.\n\n',length(LAM),eig_lower);
    else
        fprintf('Found %d eigenvalues with real part in the interval [%f,%f] for the input DDE, counting multiplicity.\n\n',length(LAM),eig_lower,eig_upper);
    end
    [M0,Z,M0_vectorized,Z_vectorized] = probematrix(LAM,Phi0,Psi0,GAM,h,control_basis);
end 

[x,cost] = optimize(M0_vectorized,Z_vectorized,h,...
    control_basis,constraint,cost_weight,cost_general,gamma,guess,searchmode,options);

control = cell(2);
control{1} = x;
control{2} = zeros(n,n);
for i=1:k
    control{2} = control{2} + x(i)*control_basis(:,(i-1)*n+1:i*n);
end