function sol = testing_matrixmode_computingexample(A0,A1,tau,h,control,pulselimit,z)
sol = zeros(length(A0),1);
init = sol; 
T=1/h;
maxtime = pulselimit;

for i=0:maxtime-1
   options = ddeset('InitialY',init,'Jumps',[i*T,(i-1)*T],'RelTol',1e-6,'AbsTol',1e-9);
   sol = dde23(@(t,y,Z)odes(t,y,Z,tau),tau,sol,[T*i,T*(i+1)],options);
   init = deval(sol,T*(i+1));
   init = init + control*init;
end

% -- The DDE functions --
function dydt = odes(t,y,Z,tau)
ylag= Z(:,1);
dydt = 1000*(ones(30,1) + 0.1*sin(t*z)) + A0*y + A1*ylag;
end

end