function sol = testing_matrixmode_networkexample_nonlinear(A0,A1,tau,h,control,pulselimit,A,V,W)
sol = randn(length(A0),1);
init = sol; 
T=1/h;
maxtime = pulselimit;

A11 = kron(A,eye(2,2));
V11 = kron(eye(100,100),V);
W11 = kron(eye(100,100),W);

for i=0:maxtime-1
   options = ddeset('InitialY',init,'Jumps',[i*T,(i-1)*T],'RelTol',1e-6,'AbsTol',1e-9);
   sol = dde23(@(t,y,Z)odes(t,y,Z,tau),tau,sol,[T*i,T*(i+1)],options);
   init = deval(sol,T*(i+1));
   init = init + control*init;
end

% -- The DDE functions --
function dydt = odes(t,y,Z,tau)
ylag= Z(:,1);
dydt = -y + V11*tanh(y) + W11*tanh(ylag) + A11*y;
end

end