% This function computes the matrices M0 and Z given inputs from dde_data,
% frequency (h) and a basis (basis) for the prescribed subspace. The
% basis must be input as a n*(nk) matrix, such that basis(:,(i-1)*n+1:i*n) is
% the ith element of your basis. For instance, {[1,0;1,0], [0,0;0,1]} 
% would be input as basis=[[1,0;1,0],[0,0;0,1]]. 

function [M0,Z,M0_vectorized,Z_vectorized] = probematrix(LAM,Phi0,Psi0,GAM,h,basis)
n=size(basis)*[1;0];
dim = (1/n)*size(basis)*[0;1];
Z = expm((1/h)*LAM);
Phi0Z_kron = kron(eye(dim),Phi0*Z);
M0 = GAM*Psi0*basis*Phi0Z_kron;

d=length(Z);
Z_vectorized = reshape(Z,[d^2,1]);
k=(1/n)*size(basis)*[0;1];
M0_reshape = reshape(M0,[k*d^2,1]);
M0_vectorized = zeros(d^2,k);
for i=1:k
    M0_vectorized(:,i) = M0_reshape(1+(i-1)*d^2:i*d^2);
end

end